Index: uspace/drv/bus/usb/xhci/hw_struct/common.h
===================================================================
--- uspace/drv/bus/usb/xhci/hw_struct/common.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/bus/usb/xhci/hw_struct/common.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -53,10 +53,10 @@
  * 4 bytes, little-endian.
  */
-typedef ioport32_t xhci_dword_t __attribute__((aligned(4)));
+typedef ioport32_t xhci_dword_t;
 
 /**
  * 8 bytes, little-endian.
  */
-typedef volatile uint64_t xhci_qword_t __attribute__((aligned(8)));
+typedef volatile uint64_t xhci_qword_t;
 
 #define XHCI_DWORD_EXTRACT(field, hi, lo) \
Index: uspace/drv/bus/usb/xhci/hw_struct/context.h
===================================================================
--- uspace/drv/bus/usb/xhci/hw_struct/context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/bus/usb/xhci/hw_struct/context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -53,4 +53,5 @@
 	xhci_dword_t data3;
 	xhci_dword_t reserved[3];
+} xhci_ep_ctx_t;
 
 #define XHCI_EP_COUNT 31
@@ -107,6 +108,4 @@
 #define XHCI_EP_MAX_ESIT_PAYLOAD_HI(ctx) XHCI_DWORD_EXTRACT((ctx).data[0], 31, 24)
 
-} __attribute__((packed)) xhci_ep_ctx_t;
-
 enum {
 	EP_STATE_DISABLED = 0,
@@ -123,4 +122,5 @@
 	xhci_dword_t data [4];
 	xhci_dword_t reserved [4];
+} xhci_slot_ctx_t;
 
 #define XHCI_SLOT_ROUTE_STRING_SET(ctx, val) \
@@ -165,6 +165,4 @@
 #define XHCI_SLOT_STATE(ctx)            XHCI_DWORD_EXTRACT((ctx).data[3], 31, 27)
 
-} __attribute__((packed)) xhci_slot_ctx_t;
-
 enum {
 	SLOT_STATE_DISABLED = 0,
@@ -213,4 +211,6 @@
 typedef struct xhci_stream_ctx {
 	uint64_t data [2];
+} xhci_stream_ctx_t;
+
 #define XHCI_STREAM_DCS(ctx)     XHCI_QWORD_EXTRACT((ctx).data[0],  0, 0)
 #define XHCI_STREAM_SCT(ctx)     XHCI_QWORD_EXTRACT((ctx).data[0],  3, 1)
@@ -222,5 +222,4 @@
 #define XHCI_STREAM_DEQ_PTR_SET(ctx, val) \
 	xhci_qword_set_bits(&(ctx).data[0], (val >> 4), 63, 4)
-} __attribute__((packed)) xhci_stream_ctx_t;
 
 /**
@@ -234,4 +233,6 @@
 typedef struct xhci_input_ctrl_ctx {
 	uint32_t data [8];
+} __attribute__((packed)) xhci_input_ctrl_ctx_t;
+
 #define XHCI_INPUT_CTRL_CTX_DROP(ctx, idx) \
     XHCI_DWORD_EXTRACT((ctx).data[0], (idx), (idx))
@@ -252,5 +253,4 @@
 #define XHCI_INPUT_CTRL_CTX_ALTER_SETTING(ctx) \
     XHCI_DWORD_EXTRACT((ctx).data[7], 23, 16)
-} __attribute__((packed)) xhci_input_ctrl_ctx_t;
 
 /**
@@ -281,5 +281,5 @@
 	uint8_t reserved;
 	uint8_t ports [];
-} __attribute__((packed)) xhci_port_bandwidth_ctx_t;
+} xhci_port_bandwidth_ctx_t;
 
 #endif
Index: uspace/drv/char/i8042/i8042.c
===================================================================
--- uspace/drv/char/i8042/i8042.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/char/i8042/i8042.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -2,5 +2,5 @@
  * Copyright (c) 2001-2004 Jakub Jermar
  * Copyright (c) 2006 Josef Cejka
- * Copyright (c) 2017 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2011 Jan Vesely
  * All rights reserved.
@@ -123,11 +123,10 @@
  * Write new data to the corresponding buffer.
  *
- * @param call pointerr to call data.
- * @param dev  Device that caued the interrupt.
- *
- */
-static void i8042_irq_handler(ipc_call_t *call, ddf_dev_t *dev)
-{
-	i8042_t *controller = ddf_dev_data_get(dev);
+ * @param call Pointer to call data.
+ * @param arg  Argument (i8042_t *)
+ */
+static void i8042_irq_handler(ipc_call_t *call, void *arg)
+{
+	i8042_t *controller = (i8042_t *)arg;
 	errno_t rc;
 
@@ -146,4 +145,7 @@
 	fibril_mutex_unlock(&port->buf_lock);
 	fibril_condvar_broadcast(&port->buf_cv);
+
+	async_sess_t *parent_sess = ddf_dev_parent_sess_get(controller->dev);
+	hw_res_clear_interrupt(parent_sess, port->irq);
 }
 
@@ -175,4 +177,6 @@
 	bool aux_bound = false;
 
+	dev->dev = ddf_dev;
+
 	if (regs->size < sizeof(i8042_regs_t)) {
 		rc = EINVAL;
@@ -202,4 +206,5 @@
 	dev->kbd->cds.ops = &i8042_chardev_ops;
 	dev->kbd->cds.sarg = dev->kbd;
+	dev->kbd->irq = irq_kbd;
 	fibril_mutex_initialize(&dev->kbd->buf_lock);
 	fibril_condvar_initialize(&dev->kbd->buf_cv);
@@ -226,4 +231,5 @@
 	dev->aux->cds.ops = &i8042_chardev_ops;
 	dev->aux->cds.sarg = dev->aux;
+	dev->aux->irq = irq_mouse;
 	fibril_mutex_initialize(&dev->aux->buf_lock);
 	fibril_condvar_initialize(&dev->aux->buf_cv);
@@ -283,5 +289,5 @@
 	cap_irq_handle_t kbd_ihandle;
 	rc = register_interrupt_handler(ddf_dev, irq_kbd,
-	    i8042_irq_handler, &irq_code, &kbd_ihandle);
+	    i8042_irq_handler, (void *)dev, &irq_code, &kbd_ihandle);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed set handler for kbd: %s.",
@@ -292,5 +298,5 @@
 	cap_irq_handle_t mouse_ihandle;
 	rc = register_interrupt_handler(ddf_dev, irq_mouse,
-	    i8042_irq_handler, &irq_code, &mouse_ihandle);
+	    i8042_irq_handler, (void *)dev, &irq_code, &mouse_ihandle);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed set handler for mouse: %s.",
Index: uspace/drv/char/i8042/i8042.h
===================================================================
--- uspace/drv/char/i8042/i8042.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/char/i8042/i8042.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2006 Josef Cejka
  * Copyright (c) 2011 Jan Vesely
@@ -76,8 +76,12 @@
 	/** Signal new data in buffer */
 	fibril_condvar_t buf_cv;
+	/** Interrupt number */
+	int irq;
 } i8042_port_t;
 
 /** i8042 Controller. */
 typedef struct i8042 {
+	/** DDF device */
+	ddf_dev_t *dev;
 	/** I/O registers. */
 	i8042_regs_t *regs;
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/char/ns8250/ns8250.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -783,10 +783,10 @@
  * data and reading the line status register.
  *
- * @param dev The serial port device.
- *
- */
-static inline void ns8250_interrupt_handler(ipc_call_t *icall, ddf_dev_t *dev)
-{
-	ns8250_t *ns = dev_ns8250(dev);
+ * @pram icall IRQ event notificatoin
+ * @param arg Argument (ns8250_t *)
+ */
+static inline void ns8250_interrupt_handler(ipc_call_t *icall, void *arg)
+{
+	ns8250_t *ns = (ns8250_t *)arg;
 	uint8_t iir = pio_read_8(&ns->regs->iid);
 	if ((iir & NS8250_IID_CAUSE_MASK) == NS8250_IID_CAUSE_RXSTATUS) {
@@ -809,5 +809,5 @@
 {
 	return register_interrupt_handler(ns->dev, ns->irq,
-	    ns8250_interrupt_handler, NULL, ihandle);
+	    ns8250_interrupt_handler, (void *)ns, NULL, ihandle);
 }
 
Index: uspace/drv/char/pl050/pl050.c
===================================================================
--- uspace/drv/char/pl050/pl050.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/char/pl050/pl050.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -143,7 +143,12 @@
 }
 
-static void pl050_interrupt(ipc_call_t *call, ddf_dev_t *dev)
-{
-	pl050_t *pl050 = (pl050_t *)ddf_dev_data_get(dev);
+/** PL050 interrupt handler
+ *
+ * @param call IRQ event notification
+ * @param arg Argument (pl050_t *)
+ */
+static void pl050_interrupt(ipc_call_t *call, void *arg)
+{
+	pl050_t *pl050 = (pl050_t *)arg;
 	size_t nidx;
 
@@ -220,5 +225,6 @@
 	cap_irq_handle_t ihandle;
 	rc = register_interrupt_handler(pl050->dev,
-	    res.irqs.irqs[0], pl050_interrupt, &pl050_irq_code, &ihandle);
+	    res.irqs.irqs[0], pl050_interrupt, (void *)pl050, &pl050_irq_code,
+	    &ihandle);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler. (%s)",
Index: uspace/drv/hid/adb-kbd/adb-kbd.c
===================================================================
--- uspace/drv/hid/adb-kbd/adb-kbd.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/adb-kbd/adb-kbd.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -34,5 +34,5 @@
 #include <ddf/log.h>
 #include <errno.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 #include <ipc/adb.h>
 #include <ipc/kbdev.h>
Index: uspace/drv/hid/adb-kbd/ctl.c
===================================================================
--- uspace/drv/hid/adb-kbd/ctl.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/adb-kbd/ctl.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -33,5 +33,5 @@
 
 #include <errno.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 #include <io/keycode.h>
 
Index: uspace/drv/hid/adb-kbd/meson.build
===================================================================
--- uspace/drv/hid/adb-kbd/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/adb-kbd/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,4 +27,5 @@
 #
 
+deps = [ 'input' ]
 src = files(
 	'main.c',
Index: uspace/drv/hid/adb-mouse/meson.build
===================================================================
--- uspace/drv/hid/adb-mouse/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/adb-mouse/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('main.c', 'adb-mouse.c')
Index: uspace/drv/hid/atkbd/atkbd.c
===================================================================
--- uspace/drv/hid/atkbd/atkbd.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/atkbd/atkbd.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,7 +38,7 @@
 #include <errno.h>
 #include <ddf/log.h>
+#include <io/kbd_event.h>
 #include <io/keycode.h>
 #include <io/chardev.h>
-#include <io/console.h>
 #include <ipc/kbdev.h>
 #include <abi/ipc/methods.h>
Index: uspace/drv/hid/atkbd/meson.build
===================================================================
--- uspace/drv/hid/atkbd/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/atkbd/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('main.c', 'atkbd.c')
Index: uspace/drv/hid/ps2mouse/meson.build
===================================================================
--- uspace/drv/hid/ps2mouse/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/ps2mouse/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('main.c', 'ps2mouse.c')
Index: uspace/drv/hid/ps2mouse/ps2mouse.c
===================================================================
--- uspace/drv/hid/ps2mouse/ps2mouse.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/ps2mouse/ps2mouse.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -40,5 +40,4 @@
 #include <io/keycode.h>
 #include <io/chardev.h>
-#include <io/console.h>
 #include <ipc/mouseev.h>
 #include <abi/ipc/methods.h>
Index: uspace/drv/hid/usbhid/kbd/kbddev.c
===================================================================
--- uspace/drv/hid/usbhid/kbd/kbddev.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/usbhid/kbd/kbddev.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -41,5 +41,5 @@
 
 #include <io/keycode.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 #include <abi/ipc/methods.h>
 #include <ipc/kbdev.h>
Index: uspace/drv/hid/usbhid/kbd/kbdrepeat.c
===================================================================
--- uspace/drv/hid/usbhid/kbd/kbdrepeat.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/usbhid/kbd/kbdrepeat.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,6 +36,6 @@
 
 #include <fibril_synch.h>
+#include <io/kbd_event.h>
 #include <io/keycode.h>
-#include <io/console.h>
 #include <errno.h>
 
Index: uspace/drv/hid/usbhid/meson.build
===================================================================
--- uspace/drv/hid/usbhid/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/usbhid/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'usbhid', 'usbdev', 'usb' ]
+deps = [ 'usbhid', 'usbdev', 'usb', 'input' ]
 includes += [ include_directories('.') ]
 src = files(
Index: uspace/drv/hid/usbhid/mouse/mousedev.c
===================================================================
--- uspace/drv/hid/usbhid/mouse/mousedev.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/usbhid/mouse/mousedev.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -46,5 +46,4 @@
 #include <str_error.h>
 #include <ipc/mouseev.h>
-#include <io/console.h>
 
 #include <ipc/kbdev.h>
Index: uspace/drv/hid/usbhid/multimedia/multimedia.c
===================================================================
--- uspace/drv/hid/usbhid/multimedia/multimedia.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/usbhid/multimedia/multimedia.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -51,5 +51,5 @@
 
 #include <ipc/kbdev.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 
 #define NAME  "multimedia-keys"
Index: uspace/drv/hid/xtkbd/meson.build
===================================================================
--- uspace/drv/hid/xtkbd/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/xtkbd/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('main.c', 'xtkbd.c')
Index: uspace/drv/hid/xtkbd/xtkbd.c
===================================================================
--- uspace/drv/hid/xtkbd/xtkbd.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/hid/xtkbd/xtkbd.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,5 +1,5 @@
 /*
+ * Copyright (c) 2022 Jiri Svoboda
  * Copyright (c) 2011 Jan Vesely
- * Copyright (c) 2017 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,5 +39,5 @@
 #include <io/keycode.h>
 #include <io/chardev.h>
-#include <io/console.h>
+#include <io/kbd_event.h>
 #include <ipc/kbdev.h>
 #include <abi/ipc/methods.h>
@@ -132,4 +132,5 @@
 	[0x58] = KC_F12,
 
+	[0x54] = KC_SYSREQ,
 	[0x46] = KC_SCROLL_LOCK,
 
@@ -163,5 +164,6 @@
 	[0x1d] = KC_RCTRL,
 
-	[0x37] = KC_SYSREQ,
+	[0x37] = KC_PRTSCR,
+	[0x46] = KC_PAUSE,
 
 	[0x52] = KC_INSERT,
@@ -198,4 +200,27 @@
 }
 
+/** Get one scancode byte from the keyboard.
+ *
+ * @param kbd Keyboard
+ * @param code Place to store scancode byte
+ * @return EOK on success or an error code
+ */
+static errno_t xtkbd_get_code(xt_kbd_t *kbd, uint8_t *code)
+{
+	errno_t rc;
+	size_t nread;
+
+	*code = 0;
+	rc = chardev_read(kbd->chardev, code, 1, &nread, chardev_f_none);
+	if (rc != EOK) {
+		ddf_msg(LVL_WARN, "Error reading from keyboard device.");
+		return EIO;
+	}
+
+	ddf_msg(LVL_DEBUG, "Read scancode: 0x%02hhx", *code);
+
+	return EOK;
+}
+
 /** Get data and parse scancodes.
  *
@@ -207,14 +232,15 @@
 static errno_t polling(void *arg)
 {
+	kbd_event_type_t evtype;
+	unsigned int key;
+	size_t map_size;
 	xt_kbd_t *kbd = arg;
-	size_t nread;
+	uint8_t code;
+	uint8_t xcode1;
+	uint8_t xcode2;
 	errno_t rc;
 
 	while (true) {
-		const unsigned int *map = scanmap_simple;
-		size_t map_size = sizeof(scanmap_simple) / sizeof(unsigned int);
-
-		uint8_t code = 0;
-		rc = chardev_read(kbd->chardev, &code, 1, &nread, chardev_f_none);
+		rc = xtkbd_get_code(kbd, &code);
 		if (rc != EOK)
 			return EIO;
@@ -226,109 +252,59 @@
 		/* Extended set */
 		if (code == KBD_SCANCODE_SET_EXTENDED) {
-			map = scanmap_e0;
-			map_size = sizeof(scanmap_e0) / sizeof(unsigned int);
-
-			rc = chardev_read(kbd->chardev, &code, 1, &nread,
-			    chardev_f_none);
+			rc = xtkbd_get_code(kbd, &xcode1);
 			if (rc != EOK)
 				return EIO;
 
-			/* Handle really special keys */
-
-			if (code == 0x2a) {  /* Print Screen */
-				rc = chardev_read(kbd->chardev, &code, 1, &nread,
-				    chardev_f_none);
-				if (rc != EOK)
-					return EIO;
-
-				if (code != 0xe0)
-					continue;
-
-				rc = chardev_read(kbd->chardev, &code, 1, &nread,
-				    chardev_f_none);
-				if (rc != EOK)
-					return EIO;
-
-				if (code == 0x37)
-					push_event(kbd->client_sess, KEY_PRESS, KC_PRTSCR);
-
+			if ((xcode1 & 0x7f) == 0x2a)  /* Fake shift */
+				continue;
+
+			/* Bit 7 indicates press/release */
+			evtype = (xcode1 & 0x80) ? KEY_RELEASE : KEY_PRESS;
+
+			map_size = sizeof(scanmap_e0) / sizeof(unsigned int);
+			key = (xcode1 & 0x7f) < map_size ?
+			    scanmap_e0[xcode1 & 0x7f] : 0;
+
+			if (key != 0)
+				push_event(kbd->client_sess, evtype, key);
+			else
+				ddf_msg(LVL_WARN, "Unknown scancode: e0 %hhx", xcode1);
+
+			continue;
+		}
+
+		/* Extended special set */
+		if (code == KBD_SCANCODE_SET_EXTENDED_SPECIAL) {
+			rc = xtkbd_get_code(kbd, &xcode1);
+			if (rc != EOK)
+				return EIO;
+
+			rc = xtkbd_get_code(kbd, &xcode2);
+			if (rc != EOK)
+				return EIO;
+
+			if ((xcode1 & 0x80) == (xcode2 & 0x80) &&
+			    (xcode1 & 0x7f) == 0x1d && (xcode2 & 0x7f) == 0x45) {
+				/* Pause */
+				evtype = (xcode1 & 0x80) ? KEY_RELEASE :
+				    KEY_PRESS;
+				push_event(kbd->client_sess, evtype, KC_PAUSE);
 				continue;
 			}
 
-			if (code == 0x46) {  /* Break */
-				rc = chardev_read(kbd->chardev, &code, 1, &nread,
-				    chardev_f_none);
-				if (rc != EOK)
-					return EIO;
-
-				if (code != 0xe0)
-					continue;
-
-				rc = chardev_read(kbd->chardev, &code, 1, &nread,
-				    chardev_f_none);
-				if (rc != EOK)
-					return EIO;
-
-				if (code == 0xc6)
-					push_event(kbd->client_sess, KEY_PRESS, KC_BREAK);
-
-				continue;
-			}
-		}
-
-		/* Extended special set */
-		if (code == KBD_SCANCODE_SET_EXTENDED_SPECIAL) {
-			rc = chardev_read(kbd->chardev, &code, 1, &nread,
-			    chardev_f_none);
-			if (rc != EOK)
-				return EIO;
-
-			if (code != 0x1d)
-				continue;
-
-			rc = chardev_read(kbd->chardev, &code, 1, &nread,
-			    chardev_f_none);
-			if (rc != EOK)
-				return EIO;
-
-			if (code != 0x45)
-				continue;
-
-			rc = chardev_read(kbd->chardev, &code, 1, &nread,
-			    chardev_f_none);
-			if (rc != EOK)
-				return EIO;
-
-			if (code != 0xe1)
-				continue;
-
-			rc = chardev_read(kbd->chardev, &code, 1, &nread,
-			    chardev_f_none);
-			if (rc != EOK)
-				return EIO;
-
-			if (code != 0x9d)
-				continue;
-
-			rc = chardev_read(kbd->chardev, &code, 1, &nread,
-			    chardev_f_none);
-			if (rc != EOK)
-				return EIO;
-
-			if (code == 0xc5)
-				push_event(kbd->client_sess, KEY_PRESS, KC_PAUSE);
-
+			ddf_msg(LVL_WARN, "Unknown scancode: e1 %hhx %hhx",
+			    xcode1, xcode2);
 			continue;
 		}
 
 		/* Bit 7 indicates press/release */
-		const kbd_event_type_t type =
-		    (code & 0x80) ? KEY_RELEASE : KEY_PRESS;
-		code &= ~0x80;
-
-		const unsigned int key = (code < map_size) ? map[code] : 0;
+		evtype = (code & 0x80) ? KEY_RELEASE : KEY_PRESS;
+
+		map_size = sizeof(scanmap_simple) / sizeof(unsigned int);
+		key = (code & 0x7f) < map_size ?
+		    scanmap_simple[code & 0x7f] : 0;
 
 		if (key != 0)
-			push_event(kbd->client_sess, type, key);
+			push_event(kbd->client_sess, evtype, key);
 		else
 			ddf_msg(LVL_WARN, "Unknown scancode: %hhx", code);
Index: uspace/drv/meson.build
===================================================================
--- uspace/drv/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -33,6 +33,7 @@
 	'root/virt',
 	'block/ahci',
-	'block/ata_bd',
 	'block/ddisk',
+	'block/isa-ide',
+	'block/pci-ide',
 	'block/usbmast',
 	'block/virtio-blk',
Index: uspace/drv/nic/ar9271/wmi.c
===================================================================
--- uspace/drv/nic/ar9271/wmi.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/nic/ar9271/wmi.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -230,4 +230,8 @@
 	size_t buffer_size = header_size + command_length;
 	void *buffer = malloc(buffer_size);
+	if (buffer == NULL) {
+		usb_log_error("Failed to allocate WMI message buffer (out of memory).\n");
+		return ENOMEM;
+	}
 
 	if (command_buffer != NULL)
@@ -241,14 +245,12 @@
 	    host2uint16_t_be(++htc_device->sequence_number);
 
-	/* Send message. */
+	/* Send message (buffer will not be needed afterwards regardless of result). */
 	errno_t rc = htc_send_control_message(htc_device, buffer, buffer_size,
 	    htc_device->endpoints.wmi_endpoint);
-	if (rc != EOK) {
-		free(buffer);
+	free(buffer);
+	if (rc != EOK) {
 		usb_log_error("Failed to send WMI message. Error: %s\n", str_error_name(rc));
 		return rc;
 	}
-
-	free(buffer);
 
 	bool clean_resp_buffer = false;
@@ -267,5 +269,4 @@
 		    response_buffer_size, NULL);
 		if (rc != EOK) {
-			free(buffer);
 			usb_log_error("Failed to receive WMI message response. "
 			    "Error: %s\n", str_error_name(rc));
@@ -275,5 +276,4 @@
 		if (response_buffer_size < sizeof(htc_frame_header_t) +
 		    sizeof(wmi_command_header_t)) {
-			free(buffer);
 			usb_log_error("Corrupted response received.\n");
 			return EINVAL;
Index: uspace/drv/nic/e1k/e1k.c
===================================================================
--- uspace/drv/nic/e1k/e1k.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/nic/e1k/e1k.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1244,12 +1244,11 @@
  *
  * @param icall IPC call structure
- * @param dev   E1000 device
- *
- */
-static void e1000_interrupt_handler(ipc_call_t *icall,
-    ddf_dev_t *dev)
+ * @param arg   Argument (nic_t *)
+ *
+ */
+static void e1000_interrupt_handler(ipc_call_t *icall, void *arg)
 {
 	uint32_t icr = (uint32_t) ipc_get_arg2(icall);
-	nic_t *nic = NIC_DATA_DEV(dev);
+	nic_t *nic = (nic_t *)arg;
 	e1000_t *e1000 = DRIVER_DATA_NIC(nic);
 
@@ -1283,5 +1282,5 @@
 
 	errno_t rc = register_interrupt_handler(nic_get_ddf_dev(nic), e1000->irq,
-	    e1000_interrupt_handler, &e1000_irq_code, handle);
+	    e1000_interrupt_handler, (void *)nic, &e1000_irq_code, handle);
 
 	fibril_mutex_unlock(&irq_reg_mutex);
Index: uspace/drv/nic/ne2k/ne2k.c
===================================================================
--- uspace/drv/nic/ne2k/ne2k.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/nic/ne2k/ne2k.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -121,5 +121,5 @@
 };
 
-static void ne2k_interrupt_handler(ipc_call_t *, ddf_dev_t *);
+static void ne2k_interrupt_handler(ipc_call_t *, void *);
 
 static errno_t ne2k_register_interrupt(nic_t *nic_data,
@@ -161,5 +161,6 @@
 
 	return register_interrupt_handler(nic_get_ddf_dev(nic_data),
-	    ne2k->irq, ne2k_interrupt_handler, &ne2k->code, handle);
+	    ne2k->irq, ne2k_interrupt_handler, (void *)nic_data, &ne2k->code,
+	    handle);
 }
 
@@ -237,7 +238,12 @@
 }
 
-void ne2k_interrupt_handler(ipc_call_t *call, ddf_dev_t *dev)
-{
-	nic_t *nic_data = DRIVER_DATA(dev);
+/** NE2K interrupt handler
+ *
+ * @param call IRQ event notification
+ * @param arg Argument (nic_t *)
+ */
+void ne2k_interrupt_handler(ipc_call_t *call, void *arg)
+{
+	nic_t *nic_data = (nic_t *)arg;
 	ne2k_interrupt(nic_data, IRQ_GET_ISR(*call), IRQ_GET_TSR(*call));
 }
Index: uspace/drv/nic/rtl8139/driver.c
===================================================================
--- uspace/drv/nic/rtl8139/driver.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/nic/rtl8139/driver.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -819,14 +819,11 @@
  *
  * @param icall  The IPC call structure
- * @param dev    The rtl8139 device
- *
- */
-static void rtl8139_interrupt_handler(ipc_call_t *icall, ddf_dev_t *dev)
-{
-	assert(dev);
-	assert(icall);
-
+ * @param arg    Argument (nic_t *)
+ *
+ */
+static void rtl8139_interrupt_handler(ipc_call_t *icall, void *arg)
+{
 	uint16_t isr = (uint16_t) ipc_get_arg2(icall);
-	nic_t *nic_data = nic_get_from_ddf_dev(dev);
+	nic_t *nic_data = (nic_t *)arg;
 	rtl8139_t *rtl8139 = nic_get_specific(nic_data);
 
@@ -861,5 +858,6 @@
 	rtl8139_irq_code.cmds[3].addr = rtl8139->io_addr + IMR;
 	errno_t rc = register_interrupt_handler(nic_get_ddf_dev(nic_data),
-	    rtl8139->irq, rtl8139_interrupt_handler, &rtl8139_irq_code, handle);
+	    rtl8139->irq, rtl8139_interrupt_handler, (void *)nic_data,
+	    &rtl8139_irq_code, handle);
 
 	RTL8139_IRQ_STRUCT_UNLOCK();
Index: uspace/drv/nic/rtl8169/driver.c
===================================================================
--- uspace/drv/nic/rtl8169/driver.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/nic/rtl8169/driver.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -74,5 +74,5 @@
 static errno_t rtl8169_on_stopped(nic_t *nic_data);
 static void rtl8169_send_frame(nic_t *nic_data, void *data, size_t size);
-static void rtl8169_irq_handler(ipc_call_t *icall, ddf_dev_t *dev);
+static void rtl8169_irq_handler(ipc_call_t *icall, void *);
 static inline errno_t rtl8169_register_int_handler(nic_t *nic_data,
     cap_irq_handle_t *handle);
@@ -372,5 +372,6 @@
 	rtl8169_irq_code.cmds[3].addr = rtl8169->regs + IMR;
 	errno_t rc = register_interrupt_handler(nic_get_ddf_dev(nic_data),
-	    rtl8169->irq, rtl8169_irq_handler, &rtl8169_irq_code, handle);
+	    rtl8169->irq, rtl8169_irq_handler, (void *)rtl8169,
+	    &rtl8169_irq_code, handle);
 
 	return rc;
@@ -1033,12 +1034,13 @@
 }
 
-static void rtl8169_irq_handler(ipc_call_t *icall, ddf_dev_t *dev)
-{
-	assert(dev);
-	assert(icall);
-
+/** RTL8169 IRQ handler.
+ *
+ * @param icall IRQ event notification
+ * @param arg Argument (rtl8169_t *)
+ */
+static void rtl8169_irq_handler(ipc_call_t *icall, void *arg)
+{
 	uint16_t isr = (uint16_t) ipc_get_arg2(icall) & INT_KNOWN;
-	nic_t *nic_data = nic_get_from_ddf_dev(dev);
-	rtl8169_t *rtl8169 = nic_get_specific(nic_data);
+	rtl8169_t *rtl8169 = (rtl8169_t *)arg;
 
 	ddf_msg(LVL_DEBUG, "rtl8169_irq_handler(): isr=0x%04x", isr);
@@ -1050,5 +1052,5 @@
 		/* Packet underrun or link change */
 		if (isr & INT_PUN) {
-			rtl8169_link_change(dev);
+			rtl8169_link_change(rtl8169->dev);
 			pio_write_16(rtl8169->regs + ISR, INT_PUN);
 		}
@@ -1056,5 +1058,5 @@
 		/* Transmit notification */
 		if (isr & (INT_TER | INT_TOK | INT_TDU)) {
-			rtl8169_transmit_done(dev);
+			rtl8169_transmit_done(rtl8169->dev);
 			pio_write_16(rtl8169->regs + ISR, (INT_TER | INT_TOK | INT_TDU));
 		}
@@ -1072,5 +1074,5 @@
 
 		if (isr & (INT_RER | INT_ROK)) {
-			rtl8169_receive_done(dev);
+			rtl8169_receive_done(rtl8169->dev);
 			pio_write_16(rtl8169->regs + ISR, (INT_RER | INT_ROK));
 		}
Index: uspace/drv/nic/virtio-net/virtio-net.c
===================================================================
--- uspace/drv/nic/virtio-net/virtio-net.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/nic/virtio-net/virtio-net.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -70,7 +70,12 @@
 };
 
-static void virtio_net_irq_handler(ipc_call_t *icall, ddf_dev_t *dev)
-{
-	nic_t *nic = ddf_dev_data_get(dev);
+/** VirtIO net IRQ handler.
+ *
+ * @param icall IRQ event notification
+ * @param arg Argument (nic_t *)
+ */
+static void virtio_net_irq_handler(ipc_call_t *icall, void *arg)
+{
+	nic_t *nic = (nic_t *)arg;
 	virtio_net_t *virtio_net = nic_get_specific(nic);
 	virtio_dev_t *vdev = &virtio_net->virtio_dev;
@@ -164,5 +169,6 @@
 
 	return register_interrupt_handler(dev, virtio_net->irq,
-	    virtio_net_irq_handler, &irq_code, &virtio_net->irq_handle);
+	    virtio_net_irq_handler, (void *)nic, &irq_code,
+	    &virtio_net->irq_handle);
 }
 
